#include <Wire.h>
#include <TM1637Display.h>
#include <DS3231.h>
#include <EEPROM.h>  //#include <EEPROMex.h>

DS3231 clock; // ПОДКЛЮЧЕНИЕ DS3231 SDA, SCL, SQW / A4, A5, D6
RTCDateTime DateTime;
TM1637Display display(4, 5);// ПОДКЛЮЧЕНИЕ TM1637 CLK,DIO / 4, 5

int k,alarm_m,alarm_h;
byte w = 1,x,y,z,menu,ton,on=1;

uint8_t date_s[]{0,0,0,0};// second
uint8_t date_t[]{0x78,0,0,0};// t
uint8_t date_on[]{0,0,0x3f,0x37};// ON
uint8_t date_off[]{0,0x3f,0x71,0x71};// OFF
int set_y,set_mon,set_d,set_h,set_m;// год, месяц, дата, часы и минуты
int menu1,w1;

void setup() {
//clock.setDateTime(__DATE__, __TIME__);
display.setBrightness(1);// яркость TM1637 0-7
Wire.begin(); clock.begin();
pinMode(6,INPUT);pinMode(10,INPUT_PULLUP);pinMode(11,INPUT_PULLUP);pinMode(12,INPUT_PULLUP);pinMode(9,INPUT_PULLUP);
alarm_m = EEPROM.read(0);alarm_h = EEPROM.read(1);z = EEPROM.read(3);// ЧТЕНИЕ EEPROM
}

void loop() {

DateTime = clock.getDateTime(); // ОПРОС ВРЕМЕНИ
k = DateTime.hour*100+DateTime.minute; // ВРЕМЯ КАК ЧИСЛО ННММ

if(digitalRead(6) == HIGH){x = 0x40;}else{x = 0x00;} // МИГАНИЕ ДВОЕТОЧИЯ

////////////////////////////// корректировка часов ////////////////////////////////////////////////
set_y=DateTime.year;
set_mon=DateTime.month;
set_d=DateTime.day;
set_h=DateTime.hour;
set_m=DateTime.minute;

if(digitalRead(9) == HIGH){menu1++;delay(300);menu=100;if(menu1 > 3){menu1 = 0;}} // ПЕРЕБОР настроек редактирования времени
// menu1 = 1 — установка года
// menu1 = 2 — установка месяца и даты
// menu1 = 3 — установка часов и минут
// menu1 = 0 — корректировка времени не активна

// корректировка года
if(menu1 == 1){y = true;x = 0x00;k = set_y; //выводим на индикатор год
if(digitalRead(12) == HIGH){set_y++;delay(300);w1 = 0;}if(set_y > 2100){set_y = 2019;}
if(digitalRead(11) == HIGH){set_y--;delay(300);w1 = 0;}if(set_y < 2019){set_y = 2019;}
}

// корректировка дата и месяц
if(menu1 == 2){y = false;x = 0x00;k = set_mon*100+set_d; //выводим на индикатор месяц и день
if(digitalRead(12) == HIGH){set_mon++;delay(300);w1 = 0;}if(set_mon > 12){set_mon = 1;}// прибавляем месяц
if(digitalRead(11) == HIGH){set_d++;delay(300);w1 = 0;}if(set_d > 31){set_d = 1;}// прибавляем год
}

// корректировка часов и минут

if(menu1 == 3){y = false;x = 0x40;k = set_h*100+set_m; //выводим на индикатор часы и минуты
if(digitalRead(12) == HIGH){set_h++;delay(300);w1 = 0;}if(set_h > 23){set_h = 0;}// прибавляет часы
if(digitalRead(11) == HIGH){set_m++;delay(300);w1 = 0;}if(set_m > 59){set_m= 0;} // прибавляем минуты
}

// записываем в память часов новые значения времени

if(w1==0){clock.setDateTime(set_y, set_mon, set_d, set_h, set_m, 0);w1=1;}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////

if(digitalRead(10) == HIGH){menu++;delay(300);menu1=100;if(menu > 6){menu = 0;}} // ПЕРЕБОР МЕНЮ

if(menu == 0){y = false;if(w == 0){EEPROM.update(0,alarm_m);EEPROM.update(1,alarm_h);EEPROM.update(3,z);}
w = 1;} // ПРИ ВЫХОДЕ ИЗ МЕНЮ ОБНОВЛЕНИЕ EEPROM

if(menu == 1){k = DateTime.second;date_s[2] = display.encodeDigit((k/10)%10);
date_s[3] = display.encodeDigit((k%10)%10);display.setSegments(date_s);} // ВЫВОД СЕКУНД

if(menu == 2){k = DateTime.day*100 + DateTime.month;x = 0x00;} // ВЫВОД ДАТЫ И МЕСЯЦА

if(menu == 3){k = clock.readTemperature();date_t[2] = display.encodeDigit((k/10)%10);
date_t[3] = display.encodeDigit((k%10)%10);display.setSegments(date_t);} // ВЫВОД ТЕМПЕРАТУРЫ

if(menu == 4){y = true;x = 0x40;k = alarm_h*100+alarm_m; // УСТАНОВКА БУДИЛЬНИКА
if(digitalRead(12) == HIGH){alarm_m++;delay(300);}if(alarm_m > 59){alarm_m = 0;} // МИНУТЫ БУДИЛЬНИКА
if(digitalRead(11) == HIGH){alarm_h++;delay(300);}if(alarm_h > 24){alarm_h = 0;} // ЧАСЫ БУДИЛЬНИКА
w = 0;}

if(menu == 5){
if(digitalRead(11) == HIGH){on=1;delay(300);}if(on==1){display.setSegments(date_on);} // БУДИЛЬНИК ВКЛЮЧЕН
if(digitalRead(12) == HIGH){on=0;delay(300);}if(on==0){display.setSegments(date_off);} // БУДИЛЬНИК ВЫКЛЮЧЕН
}

if(menu == 6){y = false;x = 0x00;k = z; // НАСТРОЙКА ЯРКОСТИ ИНДИКАТОРА
if(digitalRead(11) == HIGH){z++;delay(500);}if(z > 7){z = 0;}
if(digitalRead(12) == HIGH){z--;delay(500);}if(z > 8){z = 7;}
w = 0;}

if(digitalRead(11)==HIGH||digitalRead(12)==HIGH){ton=1;} // ПРИ НАЖАТИИ НА КНОПУ + ИЛИ — ПРЕРЫВАЕТСЯ СИГНАЛ БУДИЛНИКА
if(DateTime.hour*100+DateTime.minute!=alarm_h*100+alarm_m){ton=0;}
if(on==1){pic();}

display.setBrightness(z);

if(menu1>0&&menu1<100){display.showNumberDecEx(k,x,y);}
if(menu1==0){if(menu == 3 || menu == 5 || menu == 1){}else{display.showNumberDecEx(k,x,y);}}
}
void pic(){if(ton==0&&(DateTime.hour*100+DateTime.minute==alarm_h*100+alarm_m)){tone(7,1000,500);delay(1000);}} // СИГНАЛ БУДИЛЬНИКА, 7 ЦИФРОВОЙ ВЫХОД
